# frozen_string_literal: true

module Martinet
  class << self
    attr_writer :configuration
  end

  def self.configuration
    @configuration ||= Configuration.new
  end

  def self.reset
    @configuration = Configuration.new
  end

  def self.configure
    yield(configuration)
  end

  class Configuration
    attr_accessor :enable_impersonation

    def initialize
      @enable_impersonation = true
    end
  end
end
